
<!doctype html>
<html lang="en">




<head>
    <title>How to Kickstart RHEL8.4+0Virt - Attune Automation</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport"
          content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="title"
          content="How to Kickstart RHEL8.4+0Virt - Attune Automation">
    <meta name="description"
          content="">
    <meta name="robots"
          content="follow, index, max-snippet:-1, max-video-preview:-1, max-image-preview:large">

    <meta property="og:locale" content="en_AU" />
    <meta property="og:type" content="article" />
    <meta property="og:title"
          content="HowTo Kickstart RHEL8.4+0Virt - Attune Automation" />
    <meta property="og:description" content="" />
    <meta property="og:site_name" content="Attune Automation" />
    <meta property="article:section" content="IT Instruction" />

    <meta name="twitter:title"
          content="How to Kickstart RHEL8.4+0Virt - Attune Automation" />
    <meta name="twitter:description" content="" />

    <link rel="icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-32x32.png" sizes="32x32">
    <link rel="icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-192x192.png" sizes="192x192">
    <link rel="apple-touch-icon" href="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-180x180.png">
    <meta name="msapplication-TileImage" content="https://www.servertribe.com/wp-content/uploads/2020/10/cropped-server_tribe_favicon-270x270.png">
    <link rel="stylesheet"
          href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
          integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
          crossorigin="anonymous">
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/themes/prism-tomorrow.min.css">
    <link rel="stylesheet" href="../styles/style.css">

</head>


<body>

<!-- Project breadcrumbs -->

<!-- Project breadcrumbs -->
<nav aria-label="breadcrumb">
    <ol class="breadcrumb m-0">
        <li class="breadcrumb-item" aria-current="page">
            <a
                href="https://www.servertribe.com/"
                target="_blank">
                ServerTribe
            </a>
        </li>
        <li class="breadcrumb-item" aria-current="page">
            <a
                href="https://github.com/attune-Automation/"
                target="_blank">
                Attune Automation Projects
            </a>
        </li>
        <li class="breadcrumb-item">
            <a href="../index.html">
            Kickstart Windows
            </a>
        </li>
        <li class="breadcrumb-item active" aria-current="page">
            <strong>Kickstart RHEL8.4+0Virt</strong>
        </li>
    </ol>
</nav>

<!-- Blueprint Header -->

<div class="container px-0">
    <!-- Blueprint name and description -->
    <div class="row pt-5">
        <div class="col px-0">
            <h1 class="text-left">
                How to Kickstart RHEL8.4+0Virt
            </h1>
        </div>
    </div>

<!-- Blueprint Description -->
    <div class="row pt-4">
        <div class="col-6 px-0">
            <h6 class="text-left">
                This documentation is generated by
                <a href="https://www.servertribe.com/"
                    class="badge badge-primary"
                    target="_blank">
                    Attune
                </a>
            </h6>
        </div>
        <div class="col-6 align-self-end text-right px-0">
            <h6 class="text-right">
                <a href="https://www.youtube.com/@servertribe"
                    class="badge badge-secondary"
                    target="_blank">
                    YouTube
                </a>
                <a href="https://github.com/Attune-Automation"
                    class="badge badge-secondary"
                    target="_blank">
                    GitHub
                </a>
                <a href="https://discord.com/invite/3YpJsagqUn"
                    class="badge badge-secondary"
                    target="_blank">
                    Discord
                </a>
                <a href="https://www.linkedin.com/company/servertribe/"
                    class="badge badge-secondary"
                    target="_blank">
                    LinkedIn
                </a>
                <a href="http://doc.servertribe.com/"
                    class="badge badge-secondary"
                    target="_blank">
                    Documentation
                </a>
            </h6>
        </div>
    </div>
    <hr>
</div>

<div class="documentation">
    <div class="container px-0">
        <div class="row">

<!-- Blueprint ToC -->


            <div class="col-lg-2 px-0 pr-5">
                <div class="container px-0 pt-3 sticky-top">
                    <h6 class="pb-2">
                        <strong>Contents</strong>
                    </h6>
                    <h6 class="text-muted">
                        <a href="#top">
                            <strong>Kickstart RHEL8.4+0Virt</strong>
                        </a>
                    </h6>


    
        

                    <h6 class="text-muted pt-2">
                        <a href="#kscleanbuildfiles">
                            <strong>Step 1 -</strong> KS Clean Build Files
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksrh84deploybootiso">
                            <strong>Step 2 -</strong> KS RH84 Deploy Boot ISO
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksrh84deploykickstartconfig">
                            <strong>Step 3 -</strong> KS RH84 Deploy Kickstart Config
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksrh84deployrpmcacertificate">
                            <strong>Step 4 -</strong> KS RH84 Deploy RPM CA Certificate
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksrh84createbootiso">
                            <strong>Step 5 -</strong> KS RH84 Create Boot ISO
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtrecreatevirtualmachine">
                            <strong>Step 6 -</strong> KS oVirt Recreate Virtual Machine
                        </a>
                    </h6>
    
        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtdeletevm">
                            <strong>Step 6.1 -</strong> KS oVirt Delete VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtcreatevm">
                            <strong>Step 6.2 -</strong> KS oVirt Create VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtaddosdisk">
                            <strong>Step 6.3 -</strong> KS oVirt Add OS Disk
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtaddnic">
                            <strong>Step 6.4 -</strong> KS oVirt Add NIC
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtcopywinpeisotohostsshsyn">
                            <strong>Step 6.5 -</strong> KS oVirt Copy WinPE ISO to Host SSH (SYN)
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksesxiloadisointovm">
                            <strong>Step 6.6 -</strong> KS ESXi Load ISO into VM
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtboottoiso">
                            <strong>Step 6.7 -</strong> KS oVirt Boot to ISO
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#ksovirtunloadisofromvm">
                            <strong>Step 6.8 -</strong> KS oVirt Unload ISO from VM
                        </a>
                    </h6>


        

                    <h6 class="text-muted pt-2">
                        <a href="#kscleanbuildfiles">
                            <strong>Step 7 -</strong> KS Clean Build Files
                        </a>
                    </h6>

        

                    <h6 class="text-muted pt-2">
                        <a href="#kssshwait">
                            <strong>Step 8 -</strong> KS SSH Wait
                        </a>
                    </h6>


                </div>
            </div>

<!-- Blueprint Contents -->
            <div class="col-lg-8 pt-3">
                <div class="container">


        <div class="blueprint-description jumbotron">
            <h2 class="display-3 text-center">
                Automate This
            </h2>
            <p class="lead text-center">
                Use the <strong>Attune GUI</strong> for your Scripts
            </p>
            <p class="lead">
                <ol>
                    <a href="https://www.servertribe.com/download-attune-registration/"
                        target="_blank">
                        <span class="badge badge-primary">1</span>
                        Download Attune
                        <i class="fa-solid fa-download fa-beat-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://github.com/attune-Automation/"
                        target="_blank">
                        <span class="badge badge-primary">2</span>
                         Copy the Attune Project URL
                         <i class="fa-brands fa-github fa-fade"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://servertribe-attune.readthedocs.io/en/latest/howto/design_workspace/clone_project.html"
                        target="_blank">
                        <span class="badge badge-primary">3</span>
                        Clone the Project in Attune
                         <i class="fa-solid fa-book fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://www.youtube.com/watch?v=GCWDI29rDV0"
                        target="_blank">
                        <span class="badge badge-primary">4</span>
                        Plan your Job(s)
                        <i class="fa-brands fa-youtube fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
                <ol>
                    <a href="https://www.youtube.com/watch?v=b7DhFcURkZg"
                        target="_blank">
                        <span class="badge badge-primary">5</span>
                        Run your Job(s)
                        <i class="fa-brands fa-youtube fa-fade" style="color: #0197ff;"></i>
                    </a>
                </ol>
            </p>
            <p class="lead text-center">
                You've automated: <strong>Kickstart RHEL8.4+0Virt</strong>
            </p>
            <hr class="my-4 text-center">
            <div class="col px-0">
                <p class="text-center">
                    Get the most out of automation with our get started
                    videos, product demonstrations, and more.
                </p>
                <p class="lead text-center">
                    <a class="btn btn-primary btn-lg"
                       href="https://www.servertribe.com/learn/"
                       target="_blank"
                       role="button">
                        Learn Attune Automation
                    </a>
                </p>
            </div>
        </div>

        <div class="row">
            <p>The following steps will guide you through the manual process.</p>
        </div>

<!-- Blueprint Steps -->


        



                    <div class="row pt-5">
                        <h4 id="kscleanbuildfiles">
                            <a href="#kscleanbuildfiles">
                                <strong>Step 1 -</strong> KS Clean Build Files
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>










                        <div class="row">
                            <p>
                                Connect via ssh:
                            </p>
                        </div>
                        <div class="row py-1">
                            <code class="language-sql">
ssh {linuxattuneuser}@{attuneosbuildserver}
                            </code>
                        </div>



    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
DIR=&quot;{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}&quot;
[[ -d ${DIR} ]] &amp;&amp; rm -rf ${DIR} &amp;&amp; echo &quot;Removed ${DIR}&quot; || \
    echo &quot;No directory to remove.&quot;

ISO=&quot;{ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso&quot;
[[ -f ${ISO} ]] &amp;&amp; rm -fv ${ISO} || echo &quot;No ISO to remove.&quot;
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksrh84deploybootiso">
                            <a href="#ksrh84deploybootiso">
                                <strong>Step 2 -</strong> KS RH84 Deploy Boot ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            
        </p>
        <p>
            Copy the File(s)
            <strong>RHEL8_Boot_ISO_v84.tar</strong>
            to the target node.
        </p>
        <p>
            <strong>Extract and deploy the File(s)</strong> here:
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksrh84deploykickstartconfig">
                            <a href="#ksrh84deploykickstartconfig">
                                <strong>Step 3 -</strong> KS RH84 Deploy Kickstart Config
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            <p>https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/5/html/installation_guide/s1-kickstart2-options</p>
        </p>
        <p>
            Copy the File(s)
            <strong>RHEL8_Kickstart_Config.tar</strong>
            to the target node.
        </p>
        <p>
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksrh84deployrpmcacertificate">
                            <a href="#ksrh84deployrpmcacertificate">
                                <strong>Step 4 -</strong> KS RH84 Deploy RPM CA Certificate
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    

    



    <div class="row">
        <p>
            <p>This is the root CA certificate from the Windows Ad server.  Used for all SSL security procedures and SSL to the rpm servers</p>
        </p>
        <p>
            Copy the File(s)
            <strong>AD_Root_CA_certificate.tar</strong>
            to the target node.
        </p>
        <p>
            <strong>Extract and deploy the File(s)</strong> here:
        </p>
    </div>
    <div class="row py-1">
        <code class="language-bash">
{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}/cacerts, relative to the home directory
        </code>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="ksrh84createbootiso">
                            <a href="#ksrh84createbootiso">
                                <strong>Step 5 -</strong> KS RH84 Create Boot ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
cd {ksVmwareAttuneBaseDir}/build-{targetServer.fqn}

mkisofs -o {ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso \
  -b isolinux/isolinux.bin -c isolinux/boot.cat \
  -no-emul-boot -boot-load-size 4 -boot-info-table -J -R -V &quot;KS_RHEL&quot; .
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h3 id="ksovirtrecreatevirtualmachine">
                            <a href="#ksovirtrecreatevirtualmachine">
                                <strong>Step 6 -</strong> KS oVirt Recreate Virtual Machine
                            </a>
                        </h3>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>





    




    



                    <div class="row pt-5">
                        <h4 id="ksovirtdeletevm">
                            <a href="#ksovirtdeletevm">
                                <strong>Step 6.1 -</strong> KS oVirt Delete VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>https://github.com/oVirt/ovirt-engine-sdk/blob/master/sdk/examples/remove_vm.py</p>
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
#    ca_file=&#x27;ca.pem&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
try:
    vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
    
except IndexError:
    logger.info(&quot;VM must not exist yet&quot;)
    exit(0)

# Note that the &quot;vm&quot; variable that we assigned above contains only the
# data of the VM, it doesn&#x27;t have any method like &quot;remove&quot;. Methods are
# defined in the services. So now that we have the description of the VM
# we can find the service that manages it, calling the locator method
# &quot;vm_service&quot; defined in the &quot;vms&quot; service. This locator method
# receives as parameter the identifier of the VM and retursn a reference
# to the service that manages that VM.

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

try:
    logger.info(&quot;Stopping VM&quot;)
    vm_service.stop(async_=False)
    
    # Wait till the virtual machine is down:
    while True:
        time.sleep(5)
        vm = vm_service.get()
        if vm.status == types.VmStatus.DOWN:
            break
    
except:
    logger.info(&quot;VM Must have already been stopped&quot;)
    pass

logger.info(&quot;Deleting VM&quot;)
vm_service.remove(async_=False)

# Close the connection to the server:
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtcreatevm">
                            <a href="#ksovirtcreatevm">
                                <strong>Step 6.2 -</strong> KS oVirt Create VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            <p>https://github.com/oVirt/ovirt-engine-sdk/blob/master/sdk/examples/add_vm.py</p>
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and create a new virtual machine:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Use the &quot;add&quot; method to create a new virtual machine:
vms_service.add(
    types.Vm(
        name=&#x27;{targetServer.fqn}&#x27;,
        time_zone=types.TimeZone(name=&quot;{ovirtTimeZone}&quot;),
        cluster=types.Cluster(
            name=&#x27;{ovirtClusterName}&#x27;,
        ),
        template=types.Template(
            name=&#x27;Blank&#x27;,
        ),
        memory={ovirtMemorySize}*1024*1024*1024,
        memory_policy=types.MemoryPolicy(
            ballooning=False,
            guaranteed={ovirtMemorySize}*1024*1024*1024
        ),
        cpu=types.Cpu(
            architecture=types.Architecture.X86_64,
            topology=types.CpuTopology(
                cores={ovirtCpuCount},
                sockets=1,
                threads=1
            )
        ),
        bios=types.Bios (
            type=types.BiosType.{ovirtBiosType}
        )
    ),
)

# Close the connection to the server:
connection.close()
EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtaddosdisk">
                            <a href="#ksovirtaddosdisk">
                                <strong>Step 6.3 -</strong> KS oVirt Add OS Disk
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)


connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)

logger.info(&quot;Getting the disk service&quot;)
disk_attachments_service = vms_service.vm_service(vm.id).disk_attachments_service()

diskName=&#x27;{targetServer.fqn}-disk0&#x27;

logger.info(&quot;Attaching the new disk&quot;)
disk_attachment = disk_attachments_service.add(
    types.DiskAttachment(
        disk=types.Disk(
            name=diskName,
            description=&#x27;{targetServer.fqn}-disk0&#x27;,
            format=types.DiskFormat.COW,
            provisioned_size=100 * 2**30,
            storage_domains=[
                types.StorageDomain(
                    name=&#x27;{ovirtDiskStorageName}&#x27;,
                ),
            ],
        ),
        interface=types.DiskInterface.{ovirtDiskInterface},
        bootable=True,
        active=True,
    ),
)

logger.info(&quot;Getting the disks service for the new disk&quot;)
disks_service = connection.system_service().disks_service()

logger.info(&quot;Getting the disk service for the new disk&quot;)
disk_service = disks_service.disk_service(disk_attachment.disk.id)

logger.info(&quot;Starting to wait for disk to become online&quot;)
while True:
    logger.info(&quot;Wait for disk to become online&quot;)
    time.sleep(5)
    disk = disk_service.get()
    if disk.status == types.DiskStatus.OK:
        break

logger.info(&quot;Starting disk to appear&quot;)
while True:
    logger.info(&quot;Getting disk attatchment for %s&quot;, diskName)
    disk_attachments = disk_attachments_service.list(search=&#x27;name=%s&#x27; % diskName)
    if len(disk_attachments):
        break

    logger.info(&quot;Waiting for disk to become online&quot;)
    time.sleep(5)

logger.info(&quot;Wiating for attatchment status&quot;)
while True:
    logger.info(&quot;Getting disk attatchment for %s&quot;, diskName)
    disk = connection.follow_link(disk_attachment.disk)
    
    print(disk.status)
    if disk.status == types.DiskStatus.OK:
        break

    logger.info(&quot;Waiting for disk to attatch&quot;)
    time.sleep(5)

logger.info(&quot;Disk is online and attatched&quot;)

# Close the connection to the server:
connection.close()


EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtaddnic">
                            <a href="#ksovirtaddnic">
                                <strong>Step 6.4 -</strong> KS oVirt Add NIC
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH
python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys
import ovirtsdk4 as sdk
import ovirtsdk4.types as types
logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)
# This example will connect to the server and create a new virtual machine:
# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)
# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()
logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()
# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]
# In order to specify the network that the new interface will be
# connected to we need to specify the identifier of the virtual network
# interface profile, so we need to find it. We can have duplicate names
# for vnic profiles in different clusters, so we must also find first the
# network by datacenter and cluster:
logger.info(&quot;Getting Cluster Service&quot;)
cluster = system_service.clusters_service().cluster_service(vm.cluster.id).get()
logger.info(&quot;Getting Data Centers Service&quot;)
dcs_service = connection.system_service().data_centers_service()
logger.info(&quot;Finding Data Center n.name == &#x27;{ovirtDatacenterName}&#x27;&quot;)
dc = next(
    (n for n in dcs_service.list(search=&#x27;Clusters.name=%s&#x27; % cluster.name)
     if n.name == &#x27;{ovirtDatacenterName}&#x27;),
    None
)
if not dc:
    logger.error(&quot;Failed to find data center&quot;)
    exit(1)
logger.info(&quot;Getting Networks Service&quot;)
networks_service = dcs_service.service(dc.id).networks_service()
logger.info(&quot;Finding Network n.name == &#x27;{ovirtNetworkName}&#x27;&quot;)
network = next(
    (n for n in networks_service.list()
     if n.name == &#x27;{ovirtNetworkName}&#x27;),
    None
)
if not network:
    logger.error(&quot;Failed to find network&quot;)
    exit(1)
logger.info(&quot;Getting Profiles Service&quot;)
profiles_service = connection.system_service().vnic_profiles_service()
logger.info(&quot;Finding Profile profile.name == &#x27;{ovirtNetworkName}&#x27;&quot;)
profiles = [
    p for p in profiles_service.list() 
    if p.name == &#x27;{ovirtNetworkName}&#x27; and p.network.id == network.id
]
if profiles and len(profiles) != 1:
    logger.error(&quot;Failed to find exactly one network profile, found %s&quot;, 
        len(profiles))
    exit(1)
    
profile = profiles[0]
    
# Locate the service that manages the network interface cards of the
# virtual machine:
logger.info(&quot;Getting NICs Service&quot;)
nics_service = vms_service.vm_service(vm.id).nics_service()
# Use the &quot;add&quot; method of the network interface cards service to add the
# new network interface card:
logger.info(&quot;Adding NIC name=&#x27;vnet0&#x27;&quot;)
nics_service.add(
    types.Nic(
        name=&#x27;vnet0&#x27;,
        description=&#x27;{targetServer.fqn}-vnet0&#x27;,
        interface=types.NicInterface.{oVirtNicInterface},
        vnic_profile=types.VnicProfile(
            id=profile.id,
        ),
    ),
)
# Close the connection to the server:
connection.close()
EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtcopywinpeisotohostsshsyn">
                            <a href="#ksovirtcopywinpeisotohostsshsyn">
                                <strong>Step 6.5 -</strong> KS oVirt Copy WinPE ISO to Host SSH (SYN)
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
USER_AT_HOST=&quot;{ovirtHostSshUser.user}@{ovirtHostServer.ip}&quot;
ISO_STORAGE_PATH=&quot;{ovirtIsoStoragePath}/*/images/11111111-1111-1111-1111-111111111111&quot;

ISO_STORAGE_PATH=`ssh -o PreferredAuthentications=password ${USER_AT_HOST} &quot;ls -d ${ISO_STORAGE_PATH}&quot;`
    
echo &quot;Using storage path ${ISO_STORAGE_PATH}&quot;

FROM=&quot;{ksVmwareAttuneBaseDir}/winpe_{targetServer.fqn}.iso&quot;
TO=&quot;${ISO_STORAGE_PATH}/winpe_{targetServer.fqn}.iso&quot;

scp -p \
    -o StrictHostKeyChecking=no \
    -o UserKnownHostsFile=/dev/null \
    -o  PreferredAuthentications=password \
    ${FROM} \
    ${USER_AT_HOST}:${TO}
                </code>
            </pre>
        </div>
    </div>

    <div class="row">
        <p>
            This script may require you to answer the following prompts:
        </p>
    </div>
    <div class="row">
        <table>
            <thead>
                <tr>
                    <th>
                        Prompt
                    </th>
                    <th class="prompts">
                        Answer
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        password:
                    </td>
                    <td class="prompts">
                        <code class="language-sql">
{ovirtHostSshUser.password}
                        </code>
                    </td>
                </tr>
                <tr>
                    <td>
                        Are you sure you want to continue connecting (yes/no)?
                    </td>
                    <td class="prompts">
                        <code class="language-sql">
yes
                        </code>
                    </td>
                </tr>
                <tr>
                    <td>
                        Are you sure you want to continue connecting (yes/no/[fingerprint])?
                    </td>
                    <td class="prompts">
                        <code class="language-sql">
yes
                        </code>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>




    



                    <div class="row pt-5">
                        <h4 id="ksesxiloadisointovm">
                            <a href="#ksesxiloadisointovm">
                                <strong>Step 6.6 -</strong> KS ESXi Load ISO into VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
FROM=&quot;{ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso&quot;
TO=&quot;{ksVmwareBootIsoDir}&quot;

# Create the new VM
pwsh &lt;&lt;&#x27;EOF&#x27;
$ErrorActionPreference = &quot;Stop&quot;
Import-Module VMware.VimAutomation.Core

Connect-VIServer {vmwareVcenterServer.ip} `
    -User &quot;{vmwareVcenterUser.user}&quot; `
    -Password &#x27;{vmwareVcenterUser.password}&#x27;

if ($? -eq $false) {
    Write-Host &quot;Error: Not connected.&quot;
    exit 1
}

$cd = Get-VM -Name &quot;{targetServer.fqn}&quot; | Get-CDDrive
$iso = &quot;[{ksVmwareStoragePoolName}] kickstart_isos/kickstart_{targetServer.fqn}.iso&quot;

Set-CDDrive -CD $cd `
    -IsoPath $iso `
    -StartConnected $true `
    -Confirm:$false

EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtboottoiso">
                            <a href="#ksovirtboottoiso">
                                <strong>Step 6.7 -</strong> KS oVirt Boot to ISO
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import time
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server and create a new virtual machine:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

# Find the service that manages VMs:
logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)[0]

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Booting VM to CDROM&quot;)
vm_service.start(
    volatile=True,
    vm=types.Vm(
        os=types.OperatingSystem(
            boot=types.Boot(
                devices=[
                    types.BootDevice.CDROM
                ]
            )
        )
    )
)

# additional documentation about attributes and types that can be changed:
# https://your.rhv.host/ovirt-engine/api/model#types/vm
# https://your.rhv.host/ovirt-engine/api/model#types/operating_system
# https://your.rhv.host/ovirt-engine/api/model#types/boot
# https://your.rhv.host/ovirt-engine/api/model#types/boot_device


# Wait till the virtual machine is up:
while True:
    time.sleep(5)
    vm = vm_service.get()
    if vm.status == types.VmStatus.UP:
        break

# Close the connection to the server:
connection.close()


EOF
                </code>
            </pre>
        </div>
    </div>





    



                    <div class="row pt-5">
                        <h4 id="ksovirtunloadisofromvm">
                            <a href="#ksovirtunloadisofromvm">
                                <strong>Step 6.8 -</strong> KS oVirt Unload ISO from VM
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
export PATH=~/ks_ovirt_py_venv/bin:$PATH

python3 &lt;&lt;&quot;EOF&quot;
import logging
import sys

import ovirtsdk4 as sdk
import ovirtsdk4.types as types

logging.basicConfig(stream=sys.stdout, level=logging.INFO)
logger = logging.getLogger(&quot;Attune&quot;)

# This example will connect to the server, search for a VM by name and
# remove it:

# Create the connection to the server:
connection = sdk.Connection(
    url=&#x27;https://{ovirtEngineServer.fqn}/ovirt-engine/api&#x27;,
    username=&#x27;{ovirtEngineApiUser.user}&#x27;,
    password=&#x27;{ovirtEngineApiUser.password}&#x27;,
    insecure=True,
    debug=True,
    log=logger,
)
logger.info(&quot;Connection Successful&quot;)

logger.info(&quot;Getting system_service&quot;)
system_service = connection.system_service()

logger.info(&quot;Getting vms_service&quot;)
vms_service = system_service.vms_service()

# Find the VM:
logger.info(&quot;Searchig for VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vmSearch = vms_service.list(search=&#x27;name={targetServer.fqn}&#x27;)

if not len(vmSearch):
    logger.info(&quot;VM &#x27;name={targetServer.fqn}&#x27; doesn&#x27;t exist, exiting&quot;)
    exit(0)

logger.info(&quot;Found VM &#x27;name={targetServer.fqn}&#x27;&quot;)
vm = vmSearch[0]

logger.info(&quot;Getting VM Service for VM ID=%s&quot; % vm.id)
vm_service = vms_service.vm_service(vm.id)

logger.info(&quot;Get the CDROMS Service&quot;)
cdroms_service = vm_service.cdroms_service()

logger.info(&quot;Get the first CDROM&quot;)
cdrom = cdroms_service.list()[0]

logger.info(&quot;Get the CDROM service for the first drive&quot;)
cdrom_service = cdroms_service.cdrom_service(cdrom.id)


logger.info(&quot;Eject the CDROM on PowerOn&quot;)
cdrom_service.update(
    cdrom=types.Cdrom(
        file=types.File(
            id=&#x27;&#x27;
        ),
    ),
    current=False,
)


logger.info(&quot;Close the connection to the server&quot;)
connection.close()

EOF
                </code>
            </pre>
        </div>
    </div>






        



                    <div class="row pt-5">
                        <h4 id="kscleanbuildfiles">
                            <a href="#kscleanbuildfiles">
                                <strong>Step 7 -</strong> KS Clean Build Files
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>









    


    



    <div class="row">
        <p>
            Execute the following script:
        </p>
    </div>
    <div class="row">
        <div class="col px-0">
            <pre>
                <code class="language-sql py-0">
DIR=&quot;{ksVmwareAttuneBaseDir}/build-{targetServer.fqn}&quot;
[[ -d ${DIR} ]] &amp;&amp; rm -rf ${DIR} &amp;&amp; echo &quot;Removed ${DIR}&quot; || \
    echo &quot;No directory to remove.&quot;

ISO=&quot;{ksVmwareAttuneBaseDir}/kickstart_{targetServer.fqn}.iso&quot;
[[ -f ${ISO} ]] &amp;&amp; rm -fv ${ISO} || echo &quot;No ISO to remove.&quot;
                </code>
            </pre>
        </div>
    </div>





        



                    <div class="row pt-5">
                        <h4 id="kssshwait">
                            <a href="#kssshwait">
                                <strong>Step 8 -</strong> KS SSH Wait
                            </a>
                        </h4>
                    </div>

                    <div class="blueprint-description row">
                        <p>
                            
                        </p>
                    </div>












    

    <div class="row">
        <p class="mb-0">
            Check if TCP Port <strong>0</strong> is listening.
            When the TCP Port is up, wait <strong>5</strong>
            seconds.
        </p>
        <p>Use Telnet to check if the TCP Service is accepting connections.</p>
    </div>






                    <div class="row pt-5">
                        <div class="col">
                            <h3>Completed</h3>
                            <p>
                                You have completed this instruction.
                            </p>
                        </div>
                    </div>
                </div>
            </div>

<!-- Download Attune Ad -->

            <div class="col-lg-2 px-0">
                <div class="container px-0 pt-3 pl-5 sticky-top">
                    <div class="card border-light mb-3" style="max-width: 18rem;">
                        <div class="card-body attune-ad">
                            <img
                                src="https://www.servertribe.com/wp-content/uploads/2022/06/AttuneLogoV2_powered_by.png"
                                alt="Attune - Powered by ServerTribe"
                                class="img-fluid">
                            <h5 class="card-title mt-3 text-center">
                                Automate with Attune
                            </h5>
                            <p class="card-text text-left">
                                Download the Attune Community Edition.
                            </p>
                            <p class="text-center">
                                <a href="https://www.servertribe.com/download-attune-registration/"
                                   class="btn btn-primary mt-3">
                                    DOWNLOAD!!!
                                </a>
                            </p>
                        </div>
                    </div>
                </div>
            </div>

        </div>

<!-- Join Discord -->

        <div class="row py-5">
            <div class="jumbotron">
                <h1 class="display-4 text-center">
                    Discuss this Instruction in Discord
                </h1>
                <p class="lead">

                    Join our Discord channel and connect with like-minded
                    individuals who
                    share your passion. Engage in lively discussions, gain
                    valuable insights,
                    and stay updated on the latest trends in our industry. Don't
                    miss out on
                    this opportunity to network, learn, and grow together.
                </p>
                <hr class="my-4 text-center">
                <div class="col px-0">
                    <p class="text-center">
                        Click the link below and become a part of our vibrant
                        community on
                        Discord today!
                    </p>
                    <p class="lead text-center">
                        <a class="btn btn-primary btn-lg"
                           href="https://discord.com/invite/3YpJsagqUn"
                           role="button">
                            Join NOW!!!
                        </a>
                    </p>
                </div>
            </div>
        </div>

    </div>
</div>


<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"
        integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
<script
    src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js"
    integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
    crossorigin="anonymous"></script>
<script
    src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js"
    integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
    crossorigin="anonymous"></script>

<script
    src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/js/all.min.js"></script>

<script
    src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/components/prism-core.min.js"></script>
<script
    src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.29.0/plugins/autoloader/prism-autoloader.min.js"></script>


</body>
</html>
